<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>AdminLTE 3 | Blank Page</title>

    <!-- Google Font: Source Sans Pro -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback"
    />
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  </head>
  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"
              ><i class="fas fa-bars"></i
            ></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="index3.html" class="nav-link">Home</a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">Contact</a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img
            src="dist/img/AdminLTELogo.png"
            alt="AdminLTE Logo"
            class="brand-image img-circle elevation-3"
            style="opacity: 0.8"
          />
          <span class="brand-text font-weight-light">Devcamp 120</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/user2-160x160.jpg"
                class="img-circle elevation-2"
                alt="User Image"
              />
            </div>
            <div class="info">
              <a href="#" class="d-block">Đinh Nhật Toàn</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item menu-open">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Dashboard
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                
                  <li class="nav-item">
                    <a href="voucher.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>voucher</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="menu.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Menu</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="drink.html" class="nav-link ">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Drink</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="country.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Country</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="region.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Region</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="district.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>District</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="user.html" class="nav-link ">
                      <i class="far fa-circle nav-icon"></i>
                      <p>User</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="order.html" class="nav-link active">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Order</p>
                    </a>
                  </li>
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1>Pizza</h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">User</li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <section class="content text-center">
          <div class="container">
            <h2 style="text-align: center;">Quản trị order</h2>
            <div class="jumbotron container">
              <div class="row form-group">
              <div class="col-sm-3">
                <label for="orderCode">Order code</label>
              </div>
              <div class="col-sm-9">
                <input type="text" id="input-orderCode" name="orderCode" placeholder="Order code"
                class="form-control">
              </div>
              </div>
              <div class="row form-group">
              <div class="col-sm-3">
                <label for="pizzaSize">Pizza Size</label>
              </div>
              <div class="col-sm-9">
                <input type="text" id="input-pizzaSize" name="pizzaSize" placeholder="Pizza Size" class="form-control">
              </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="pizzaType">Pizza Type</label>
                </div>
                <div class="col-sm-9">
                  <input type="text" id="input-pizzaType" name="pizzaSize" placeholder="Pizza Type" class="form-control">
                </div>
                </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="voucherCode">Voucher Code</label>
                </div>
                <div class="col-sm-9">
                  <input type="text" id="input-voucherCode" name="voucherCode" placeholder="Voucher Code" class="form-control">
                </div>
              </div>
              <div class="row form-group">
              <div class="col-sm-3">
                <label for="price">Price</label>
              </div>
              <div class="col-sm-9">
                <input type="number" id="input-price" name="price" placeholder="Price" class="form-control">
              </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="paid">Paid</label>
                </div>
                <div class="col-sm-9">
                  <input type="number" id="input-paid" name="paid" placeholder="Paid" class="form-control">
                </div>
                </div>
              <div class="row form-group">
              <div class="col-sm-3">
                <label for="createDate">Date create</label>
              </div>
              <div class="col-sm-9">
                <input type="date" date-date="" date-date-format="DD/MM/YYYY" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
              </div>
              </div>
              <div class="row form-group">
              <div class="col-sm-3">
                <label for="updateDate">Date update</label>
              </div>
              <div class="col-sm-9">
                <input type="date" date-date="" date-date-format="DD/MM/YYYY" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
              </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="user">User</label>
                </div>
                <div class="col-sm-9">
                  <select
                    id="user-select"
                    name="user"
                    class="form-control"
                  >
                  <option value="All">User order</option>
                </select>
                </div>
              </div>
              <div class="row pull-right">
              <div class="col-sm-2">
                <button id="update_data" class="btn btn-info">Update Data</button>
              </div>
              <div class="col-sm-2">
                <button id="create_data" class="btn btn-success">Create Data</button>
              </div>
              <div class="col-sm-2">
                <button id="delete_data" class="btn btn-danger">Delete Data</button>
              </div>
              <div class="col-sm-2">
                <button id="delete_all_data" class="btn btn-danger">Delete All Data</button>
              </div>
              </div>
            </div>
            <table class="table table-bordered table-striped table-hover" id="user-table">
              <thead>
                <tr>
                  <th>STT</th>
                  <th>orderCode</th>
                  <th>pizzaSize</th>
                  <th>pizzaType</th>
                  <th>voucherCode</th>
                  <th>price</th>
                  <th>paid</th>
                  <th>Date Create</th>
                  <th>Date Update</th>
                </tr>
            </table>
          </div>
        </section>
        <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block"><b>Version</b> 1.0.0</div>
        <strong
          >Copyright &copy; 2023
          <a href="https://adminlte.io">Devcamp 120</a>.</strong
        >
        All rights reserved.
      </footer>
      <!-- /.control-sidebar -->
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>

    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <script>
      "use strict";
      const gBASE_URL = "http://localhost:8080/v1/order";
      var gObjectOrder = [];
      var vId = 0;
      var table = $("#user-table").DataTable({
          "columns": [
            {"data":"id"},
            {"data":"orderCode"},
            {"data":"pizzaSize"},
            {"data":"pizzaType"},
            {"data":"voucherCode"},
            {"data":"price"},
            {"data":"paid"},
            {"data":"created"},
            {"data":"updated"},
          ]
        });
      $(document).ready(function(){
        onPageLoading();
        callApiAllOrder();
        
        $('#user-table').on('click', 'tr', function(){
            vId = $(this).find('td:first').text();
            loadOrderDataById(vId);
        });
    
        $('#update_data').on('click', function(){
            var vObj ={
              orderCode:"",
              pizzaSize:"",
              pizzaType: "",
              voucherCode:"",
              price: -1,
              paid:-1,
              created:"",
              updated:"",
            }
            getUpdateDataForm(vObj);
            getUpdateDataApi(vId, vObj);
            resetForm();
        });
        
        $('#create_data').on('click', function(){
            var vObj ={
              orderCode:"",
              pizzaSize:"",
              pizzaType: "",
              voucherCode:"",
              price: -1,
              paid:-1,
              created:"",
              updated:"",
              user: -1,
            }
            getDataForm(vObj);
            var vIsValidate = validateData(vObj);
            if(vIsValidate){
              getCreateDataApi(vObj);
              resetForm();
            }
        });
        
        $('#delete_data').on('click', function(){
          deleteOrderById(vId);
          resetForm();
        });
      
        $('#delete_all_data').on('click', function(){
          deleteAllOrderById();
        });
      });

      function onPageLoading(){
          //Get data user
        $.ajax({
          url: "http://localhost:8080/v1/user/all",
          method: "GET",
          success: function (pObjRes) {
            console.log(pObjRes);
            loadDataToUserSelect(pObjRes);
          },
          error: function (pXhrObj) {
            console.log(pXhrObj);
          },
        });
      }
      
      var gUserSelectElement = $("#user-select");

      function loadDataToUserSelect(pCountryList) {
        for (var i = 0; i < pCountryList.length; i++) {
          var bUserOption = $("<option/>");
          bUserOption.prop("value", pCountryList[i].id);
          bUserOption.prop("text", pCountryList[i].fullname);
          gUserSelectElement.append(bUserOption);
        }
      }
    
      function callApiAllOrder(){
        $.ajax({
          url: gBASE_URL + "/all",
          type: "GET",
          dataType: "json",
          success: function(res){
            gObjectOrder= res;
            DisplayOrderToTable(res);
          },
          error: function(err){
            console.log(err.response);
          }
        });
      }
      function loadOrderDataById(id) {
          fetch(`http://localhost:8080/v1/order/detail/${id}`)
          .then(response => response.json())
          .then(data => {
            // Hiển thị thông tin Drink lên form
            $('#input-orderCode').val(data.orderCode);
            $('#input-pizzaSize').val(data.pizzaSize);
            $('#input-pizzaType').val(data.pizzaType);
            $('#input-voucherCode').val(data.voucherCode);
            $('#input-price').val(data.price);
            $('#input-paid').val(data.paid);           
            $('#input-createDate').val(data.created);
            $('#input-updateDate').val(data.updated);
          })
          .catch(error => console.error(error));
        }
      function getUpdateDataApi(pId, pObject) {
          $.ajax({
            url: gBASE_URL+ "/update/" + pId,
            type: "PUT",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(pObject),
            success: function(res){
              callApiAllOrder();
            },
            error: function(err){
              console.log(err.responseText);
            }
          });
        }
      function getDataForm(paramObj){
        paramObj.orderCode = $('#input-orderCode').val();
        paramObj.pizzaSize = $('#input-pizzaSize').val();
        paramObj.pizzaType = $('#input-pizzaType').val();
        paramObj.voucherCode = $('#input-voucherCode').val();
        paramObj.price = $('#input-price').val();
        paramObj.paid = $('#input-paid').val();
        paramObj.created = $('#input-createDate').val();
        paramObj.updated = $('#input-updateDate').val();
        paramObj.user = $('#user-select').val();
      }
      function getUpdateDataForm(paramObj){
        paramObj.orderCode = $('#input-orderCode').val();
        paramObj.pizzaSize = $('#input-pizzaSize').val();
        paramObj.pizzaType = $('#input-pizzaType').val();
        paramObj.voucherCode = $('#input-voucherCode').val();
        paramObj.price = $('#input-price').val();
        paramObj.paid = $('#input-paid').val();
        paramObj.created = $('#input-createDate').val();
        paramObj.updated = $('#input-updateDate').val();
      }
      function DisplayOrderToTable(paramData) {
          "use strict";
          $("#user-table").DataTable().clear(); // xóa dữ liệu
          $("#user-table").DataTable().rows.add(paramData); //thêm các dòng dữ liệu vào datatable
          $("#user-table").DataTable().draw(); //vẽ lại bảng
        }
      function getCreateDataApi(pObject) {
        $.ajax({
          url: gBASE_URL + "/create/" + pObject.user,
          type: "POST",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(pObject),
          success: function(res){
            callApiAllOrder();
          },
          error: function(err){
            console.log(err.responseText);
          }
        });
      }
      function validateData(paramObj){
        if(paramObj.orderCode == ""){
          alert("Bạn chưa điền mã order!");
          return false;
        }
        if(paramObj.pizzaSize == ""){
          alert("Bạn chưa điền kích cỡ pizza!");
          return false;
        }
        if(paramObj.pizzaType == ""){
          alert("Bạn chưa điền loại pizza!");
          return false;
        }
        if(paramObj.voucherCode == ""){
          alert("Bạn chưa điền loại pizza!");
          return false;
        }
        if(paramObj.price == -1){
          alert("Bạn chưa điền giá đơn hàng!");
          return false;
        }
        if(paramObj.paid == -1){
          alert("Bạn chưa điền giá thanh toán!");
          return false;
        }
        return true;
      }
      function resetForm(){
        $('#input-orderCode').val("");
        $('#input-pizzaSize').val("");
        $('#input-pizzaType').val("");
        $('#input-voucherCode').val("");
        $('#input-price').val("");
        $('#input-paid').val("");
        $('#input-createDate').val("");
        $('#input-updateDate').val("");
      }
      function deleteOrderById(pId) {
        $.ajax({
          url: gBASE_URL + "/delete/" + pId,
          type: "DELETE",
          async: false,
          success: function (paramOrderRes) {
            callApiAllOrder();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
      function deleteAllOrderById() {
        $.ajax({
          url: gBASE_URL + "/deleteAll",
          type: "DELETE",
          async: false,
          success: function (paramOrderRes) {
            callApiAllOrder();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    </script>
  </body>
</html>
